Subject: Re: [PATCH] clone: support unusual remote ref configurations

From: Junio C Hamano <[email-masked]>
Date: Wed, 26 Jan 2022 13:51:04 -0800

Jonathan Tan <[email-masked]> writes:

> When cloning a branchless and tagless but not refless remote using
> protocol v0 or v1, Git calls transport_fetch_refs() with an empty ref
> list. This makes the clone fail with the message "remote transport
> reported error".

Despite what the title says, I do not think this would be so
"unusual".  To a freshly created repository, if you added a remote
or two, fetched from them, but haven't created a commit of your own
(or forked from these remotes) yet, you'd have no refs in heads/ and
tags/ but refs in refs/remotes/.

2.35 would fail as expected with "remote transport reported error"
in such a situation.  With your fix, it creates an empty repository
with expected fetch refspec.

Which looks good.